package com.tmax.openframe.variable;

import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.variable.group.*;
import java.math.*;
import java.text.DecimalFormat;
import java.util.*;
import java.util.function.BiFunction;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public class OIVPMAIN_VariableContainer {
    public @Getter String WS_TRANS_ID = "OIVP";
    public @Getter String OIVPMS1 = "OIVPM01";
    public @Getter String WS_MAP_NAME = "OIVPM01";
    public @Getter @Setter int WS_RESPONSE_CODE;
    public @Getter String WS_COMMUNICATION_AREA = StringUtils.repeat(' ', 1);
    public @Getter @Setter int WS_FIRST_TIME_FLAG;
    public @Getter @Setter OIVPMAIN_WS_ERROR_MESSAGE WS_ERROR_MESSAGE = new OIVPMAIN_WS_ERROR_MESSAGE();
    public @Getter @Setter OIVPMAIN_OIVPM01I OIVPM01I = new OIVPMAIN_OIVPM01I();

    public OIVPMAIN_OIVPM01O getOIVPM01O() {
        return OIVPMAIN_OIVPM01O.builder().FILLER8(getFILLER8())
                .FILLER9(getFILLER9()).DATEO(getDATEO())
                .FILLER10(getFILLER10()).TERMO(getTERMO())
                .FILLER11(getFILLER11()).TIMEO(getTIMEO())
                .FILLER12(getFILLER12()).CODEO(getCODEO())
                .FILLER13(getFILLER13()).IDENO(getIDENO())
                .FILLER14(getFILLER14()).MSGO(getMSGO()).build();
    }

    public void setOIVPM01O(String source) {
        setFILLER8(source.substring(0, 12));
        setFILLER9(source.substring(12, 15));
        setDATEO(source.substring(15, 23));
        setFILLER10(source.substring(23, 26));
        setTERMO(source.substring(26, 30));
        setFILLER11(source.substring(30, 33));
        setTIMEO(source.substring(33, 41));
        setFILLER12(source.substring(41, 44));
        setCODEO(source.substring(44, 48));
        setFILLER13(source.substring(48, 51));
        setIDENO(Integer.parseInt(source.substring(51, 59)));
        setFILLER14(source.substring(59, 62));
        setMSGO(source.substring(62, 138));
    }

    public void setOIVPM01O(OIVPMAIN_OIVPM01O source) {
        setOIVPM01O(source.toString());
    }

    public String getFILLER8() {
        return getOIVPM01I().getFILLER1();
    }

    public void setFILLER8(String source) {
        OIVPM01I.setFILLER1(source);
    }

    public String getFILLER9() {
        return String.valueOf(getOIVPM01I().getDATEL())
                + getOIVPM01I().getDATEF();
    }

    public void setFILLER9(String source) {
        OIVPM01I.setDATEL(Integer.parseInt(source.substring(0, 2)));
        OIVPM01I.setDATEF(source.substring(2));
    }

    public String getDATEO() {
        return getOIVPM01I().getDATEI();
    }

    public void setDATEO(String source) {
        OIVPM01I.setDATEI(source);
    }

    public String getFILLER10() {
        return String.valueOf(getOIVPM01I().getTERML())
                + getOIVPM01I().getTERMF();
    }

    public void setFILLER10(String source) {
        OIVPM01I.setTERML(Integer.parseInt(source.substring(0, 2)));
        OIVPM01I.setTERMF(source.substring(2));
    }

    public String getTERMO() {
        return getOIVPM01I().getTERMI();
    }

    public void setTERMO(String source) {
        OIVPM01I.setTERMI(source);
    }

    public String getFILLER11() {
        return String.valueOf(getOIVPM01I().getTIMEL())
                + getOIVPM01I().getTIMEF();
    }

    public void setFILLER11(String source) {
        OIVPM01I.setTIMEL(Integer.parseInt(source.substring(0, 2)));
        OIVPM01I.setTIMEF(source.substring(2));
    }

    public String getTIMEO() {
        return getOIVPM01I().getTIMEI();
    }

    public void setTIMEO(String source) {
        OIVPM01I.setTIMEI(source);
    }

    public String getFILLER12() {
        return String.valueOf(getOIVPM01I().getCODEL())
                + getOIVPM01I().getCODEF();
    }

    public void setFILLER12(String source) {
        OIVPM01I.setCODEL(Integer.parseInt(source.substring(0, 2)));
        OIVPM01I.setCODEF(source.substring(2));
    }

    public String getCODEO() {
        return getOIVPM01I().getCODEI();
    }

    public void setCODEO(String source) {
        OIVPM01I.setCODEI(source);
    }

    public String getFILLER13() {
        return String.valueOf(getOIVPM01I().getIDENL())
                + getOIVPM01I().getIDENF();
    }

    public void setFILLER13(String source) {
        OIVPM01I.setIDENL(Integer.parseInt(source.substring(0, 2)));
        OIVPM01I.setIDENF(source.substring(2));
    }

    public int getIDENO() {
        return Integer.parseInt(intFormatWithoutSign.apply((long) getOIVPM01I()
                .getIDENI(), "00000000"));
    }

    public void setIDENO(int source) {
        OIVPM01I.setIDENI(Integer.parseInt(intFormatWithoutSign.apply(
                (long) source, "00000000")));
    }

    public String getFILLER14() {
        return String.valueOf(getOIVPM01I().getMSGL())
                + getOIVPM01I().getMSGF();
    }

    public void setFILLER14(String source) {
        OIVPM01I.setMSGL(Integer.parseInt(source.substring(0, 2)));
        OIVPM01I.setMSGF(source.substring(2));
    }

    public String getMSGO() {
        return getOIVPM01I().getMSGI();
    }

    public void setMSGO(String source) {
        OIVPM01I.setMSGI(source);
    }

    public @Getter String DEFINITIONS_OF_EIBAID_FIELD = StringUtils.repeat(' ',
            1);
    public @Getter @Setter OIVPMAIN_WS_DATE_TIME_AREA WS_DATE_TIME_AREA = new OIVPMAIN_WS_DATE_TIME_AREA();
    public @Getter String FILE01 = "OIVPFILE";
    public @Getter String TDQ01 = "OIV1";
    public @Getter String TSQ01 = "OIVPTSQ";
    public @Getter @Setter int ITEM01 = 1;
    public @Getter @Setter int LEN = 4;
    public @Getter @Setter int LEN1 = 8;
    public @Getter @Setter int START_KEY = 0;
    public @Getter @Setter int DATALEN = 104;
    public @Getter @Setter OIVPMAIN_PEOPLE_INFO_GET PEOPLE_INFO_GET = new OIVPMAIN_PEOPLE_INFO_GET();
    public @Getter String START_CODE = StringUtils.repeat(' ', 2);
    public @Getter String DFHCOMMAREA = StringUtils.repeat(' ', 1);
    private final static BiFunction<Long, String, String> intFormatWithSign = (
            value, format) -> {
        DecimalFormat nf = new DecimalFormat();
        nf.applyPattern("+" + format + ";-" + format);
        return nf.format(value);
    };
    private final static BiFunction<Long, String, String> intFormatWithoutSign = (
            value, format) -> {
        DecimalFormat nf = new DecimalFormat();
        nf.setNegativePrefix("");
        nf.applyPattern(format);
        return nf.format(value);
    };

    public void setWS_TRANS_ID(String source) {
        WS_TRANS_ID = StringUtils.truncate(StringUtils.rightPad(source, 4), 4);
    }

    public void setOIVPMS1(String source) {
        OIVPMS1 = StringUtils.truncate(StringUtils.rightPad(source, 7), 7);
    }

    public void setWS_MAP_NAME(String source) {
        WS_MAP_NAME = StringUtils.truncate(StringUtils.rightPad(source, 7), 7);
    }

    public String getStringWS_RESPONSE_CODE() {
        return intFormatWithSign.apply((long) WS_RESPONSE_CODE, "00000000");
    }

    public void setWS_COMMUNICATION_AREA(String source) {
        WS_COMMUNICATION_AREA = StringUtils.truncate(
                StringUtils.rightPad(source, 1), 1);
    }

    public String getStringWS_FIRST_TIME_FLAG() {
        return intFormatWithSign.apply((long) WS_FIRST_TIME_FLAG, "0000");
    }

    public void setDEFINITIONS_OF_EIBAID_FIELD(String source) {
        DEFINITIONS_OF_EIBAID_FIELD = StringUtils.truncate(
                StringUtils.rightPad(source, 1), 1);
    }

    public void setFILE01(String source) {
        FILE01 = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public void setTDQ01(String source) {
        TDQ01 = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public void setTSQ01(String source) {
        TSQ01 = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public String getStringITEM01() {
        return intFormatWithSign.apply((long) ITEM01, "0000");
    }

    public String getStringLEN() {
        return intFormatWithSign.apply((long) LEN, "0000");
    }

    public String getStringLEN1() {
        return intFormatWithSign.apply((long) LEN1, "0000");
    }

    public String getStringSTART_KEY() {
        return intFormatWithSign.apply((long) START_KEY, "00000000");
    }

    public String getStringDATALEN() {
        return intFormatWithSign.apply((long) DATALEN, "0000");
    }

    public void setSTART_CODE(String source) {
        START_CODE = StringUtils.truncate(StringUtils.rightPad(source, 2), 2);
    }

    public void setDFHCOMMAREA(String source) {
        DFHCOMMAREA = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }
}
